#include <stdio.h>
#include "parti.h"

/****************************************************************/
void 
  bytecopy(a,b,n)
char *a,*b;
long n;
{
  long i;

  for(i=0;i<n;i++){
    a[i] = b[i];
  }
}

/****************************************************************/
/* in:                                                          */
/*   nbuckets                                                   */
/*   ndata                                                      */
/*   key[ndata]                                                 */
/*   data[ndata]                                                */
/* out:                                                         */
/*   bsize[nbuckets]                                            */
/*   *buckets[nbuckets]                                         */
/*   *perms[nbuckets]                                           */
/****************************************************************/

void 
  bsort(nbuckets,ndata,key,data,bsize,buckets,perms,blist,plist)
int nbuckets,ndata,*key,*data,*bsize,**buckets,**perms,*blist,*plist;
{
  int i,count,*bcount,b;

  /* find size of each bucket */
  for(i=0;i<nbuckets;i++) bsize[i] = 0;
  for(i=0;i<ndata;i++){
    if(key[i]>=nbuckets){
      fprintf(stderr,
       "[%d]Error in bsort: not enough buckets [i-%d, key-%d, ndata-%d]\n", 
         PARTI_mynode, i, key[i], ndata);
      exit();
    }
    bsize[key[i]]++;
  }

  /* allocate memory for buckets */
  count = 0;
  for(i=0;i<nbuckets;i++){
    buckets[i] = &blist[count];
    perms[i] = &plist[count];
    count += bsize[i];
  }

  /* do bucket sort */
  bcount = (int *) malloc(sizeof(int)*nbuckets);
  for(i=0;i<nbuckets;i++) bcount[i] = 0;
  for(i=0;i<ndata;i++){
    b = key[i];
    if ( key[i] < 0 ) {
      fprintf(stderr, "\n proc < 0 !! for data[%d] = %d ",
		       i, data[i] );
      exit(1);
    }
    buckets[b][bcount[b]] = data[i];
    perms[b][bcount[b]] = i;
    bcount[b]++;
  }
  free(bcount);

}

/****************************************************************/
void print_com_pattern_node(sched,node)
SCHED *sched;
int node;
{

  int i,j;
  FILE *fp;
  struct com_pattern *p;


  if ( node == PARTI_mynode ) {
      fp = fopen("com.out", "w");
      fprintf(fp,"\n [%2d] :", PARTI_mynode);
      for ( j=0; j<PARTI_numnodes; j++ ) {
            fprintf(fp, " %d ",p->fetch_n[j] );
      }
      fclose(fp);
   }
 PARTI_gsync();
 return;
}
/****************************************************************/
void 
  print_com_pattern(sched)
SCHED *sched;
{
  int i,j;
  FILE *fp;
  struct com_pattern *p;

  p = sched->sr;
   
for( i=0; i < PARTI_numnodes; i++ ) {
   if ( i == PARTI_mynode ) {
      fp = fopen("com.out", "w");
      fprintf(fp,"\n [%2d] :", PARTI_mynode);
      for ( j=0; j<PARTI_numnodes; j++ ) {
            fprintf(fp, " %d ",p->fetch_n[j] );
      }
      fclose(fp);
   }
   PARTI_gsync();
}
      

/*

  for(i=0;i<PARTI_numnodes;i++){
    if(p->fetch_n[i]!=0){
      printf("node %2d fetchs ",PARTI_mynode);
      for(j=0;j<p->fetch_n[i];j++){
        printf("%d ",p->fetch_list[i][j]);
      }  
      printf(" from %d\n",i);
    }  
  }   

  for(i=0;i<PARTI_numnodes;i++){
    if(p->send_n[i]!=0){
      printf("node %2d sends ",PARTI_mynode);
      for(j=0;j<p->send_n[i];j++){
        printf("%d ",p->send_list[i][j]);
      }  
      printf(" to %d\n",i);
    } 
  }
*/

}   
/****************************************************************/

void 
  check_point(s)
char *s;
{
  PARTI_gsync();
  if(PARTI_mynode==0){
    printf("%s\n",s);
  }  
}
/****************************************************************/

void  
  check_sum(x,n)
double *x;
int n;
{
  int i;
  double sum[3],wrk[3];
 
  sum[0] = 0;
  sum[1] = 0;
  sum[2] = 0;
  for(i=0;i<n;i++){
    sum[0] += x[i];
    sum[1] += x[i]*x[i];
    sum[2] += x[i]*x[i]*x[i];
  }  
 
  PARTI_gdsum(sum,3,wrk);
 
  if(PARTI_mynode==0){
    printf("check sums = %f %f %f\n",sum[0],sum[1],sum[2]);
  }  
}   
/****************************************************************/
  

void
  test_malloc()
{
  int *c,*c1;
  int found=0;
  long i;

  i = 1L;
  c = (int *)malloc(sizeof(int));
  while(found == 0){
    i++;
    c1 = c;
    c = (int *)realloc(c,sizeof(int)*i);
    if(c == NULL)
      found = 1;
  }
  c = c1;
  free(c1);
  free(c);
  printf("\tThe size is %ld: %d\n",sizeof(int)*i, PARTI_mynode);
}

void
  test_malloc_()
{
  test_malloc();
}
/****************************************************************/

void
  PairColor(GColor, MyProc)
int *GColor;
int MyProc;
{
	int i;

	for (i=0; i<PARTI_numnodes; i++) {
		GColor[i] = MyProc ^ i;
	}
}

/****************************************************************/

void
  do_malloc()
{
  double *c;
  int found=1,count=0;

   while (1){
    count++;
    c = (double *)malloc(count * sizeof(double));
    if(c == NULL){
      printf("the count is : %d\n",count*sizeof(double));
      break;
    }
    free(c);
  }
}
/****************************************************************/
